package com.example.nfctagexample;

import java.io.IOException;
import java.io.UnsupportedEncodingException;

import android.nfc.FormatException;
import android.nfc.NdefMessage;
import android.nfc.NdefRecord;
import android.nfc.NfcAdapter;
import android.nfc.Tag;
import android.nfc.tech.Ndef;
import android.os.Bundle;
import android.os.Parcelable;
import android.app.Activity;
import android.content.Intent;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity {

	private Tag myTag;
	private EditText text;
	private Button button;
	private TextView label;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		text=(EditText)findViewById(R.id.editText1);
		button=(Button)findViewById(R.id.button1);
		label=(TextView)findViewById(R.id.textView2);
		
		Toast.makeText(getApplicationContext(), "NFC Discovered", 1000);
	}
	
	
	
	protected void onResume() {
		super.onResume();
		
		if (NfcAdapter.ACTION_TAG_DISCOVERED.equals(getIntent().getAction())  || 
				NfcAdapter.ACTION_TECH_DISCOVERED.equals(getIntent().getAction()) || 
				NfcAdapter.ACTION_NDEF_DISCOVERED.equals(getIntent().getAction())) {
				
				myTag = getIntent().getParcelableExtra(NfcAdapter.EXTRA_TAG);
				String read=read(myTag,getIntent());
				label.setText(read);
				
				Toast t=Toast.makeText(this, "NFC Discovered", 100);
				t.show();
			}
	}
	
	
	/*
	protected void onNewIntent(Intent intent) {
	
		finish();
		Log.d("BUG","bug");
		
		Toast t=Toast.makeText(getApplicationContext(), "NFC Discovered", 1000);
		t.show();
		
		if (NfcAdapter.ACTION_TAG_DISCOVERED.equals(getIntent().getAction())  || 
			NfcAdapter.ACTION_TECH_DISCOVERED.equals(getIntent().getAction()) || 
			NfcAdapter.ACTION_NDEF_DISCOVERED.equals(getIntent().getAction())) {
			
			myTag = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
			Toast.makeText(this, "NFC Discovered", 100);
		}
	}
	*/

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	
	
	
	private NdefRecord createRecord(String text) throws UnsupportedEncodingException {

	      //create the message in according with the standard
	      String lang = "it";
	      byte[] textBytes = text.getBytes();
	      byte[] langBytes = lang.getBytes("US-ASCII");
	      int langLength = langBytes.length;
	      int textLength = textBytes.length;

	      byte[] payload = new byte[1 + langLength + textLength];
	      payload[0] = (byte) langLength;

	      // copy langbytes and textbytes into payload
	      System.arraycopy(langBytes, 0, payload, 1, langLength);
	      System.arraycopy(textBytes, 0, payload, 1 + langLength, textLength);

	      NdefRecord recordNFC = new NdefRecord(NdefRecord.TNF_WELL_KNOWN, NdefRecord.RTD_TEXT, new byte[0], payload);
	      return recordNFC;
	}

	
	private String read(Tag tag, Intent intent) {
		String text=null;
		
		Ndef ndef = Ndef.get(tag);
		
		Parcelable[] rawMsgs = intent.getParcelableArrayExtra(NfcAdapter.EXTRA_NDEF_MESSAGES);
		NdefMessage msg = (NdefMessage) rawMsgs[0];
	    byte[] payload = msg.getRecords()[0].getPayload();
	    text = new String(payload);
	    
	    text=(String) text.subSequence(3, text.length());
	    
		return text;
	}
	
	
	
	public void writeTag(View v) {
		if (myTag==null) {
			Toast t=Toast.makeText(getApplicationContext(), "Operation NOT permitted", 1000);
			t.show();
		} else {
			try {
				if (text.getText().length()>0) {
					write(text.getText().toString(),myTag);
					Toast t=Toast.makeText(getApplicationContext(), "Operation completed with success", 1000);
					t.show();
				}
			} catch(IOException ex) {
				Toast.makeText(this, "Unable to write on the tag", 100);
			} catch(FormatException fex) {
				Toast.makeText(this, "Unable to write on the tag", 100);
			}
		}
	}
	
	
	private void write(String text, Tag tag) throws IOException, FormatException {

	      NdefRecord[] records = { createRecord(text) };
	      NdefMessage message = new NdefMessage(records); 
	      Ndef ndef = Ndef.get(tag);
	      ndef.connect();
	      ndef.writeNdefMessage(message);
	      ndef.close();
	}
	
	

	
}
